<template>
  <div class="thumb-slider">
    <slot name="badges"></slot>
    <swiper class="swiper thumb-slider__main"
            :options="swiperOptionMain"
            ref="swiperMain">

      <swiper-slide v-for="(sliderItem, index) in sliderItems"
                    :key="`${sliderItem}-${index}`"
      >

        <base-video v-if="sliderItem.video"
                    :options="getVideoOptions(sliderItem)"
        />

        <img v-else :src="sliderItem.url" alt="">

      </swiper-slide>

      <div class="thumb-slider__arrow thumb-slider__arrow--left"
           :class="startedVideos.includes(activeIndex) ? 'thumb-slider__arrow--video' : ''"
           ref="leftArrow"
           slot="button-next"></div>
      <div class="thumb-slider__arrow thumb-slider__arrow--right"
           :class="startedVideos.includes(activeIndex) ? 'thumb-slider__arrow--video' : ''"
           slot="button-prev"></div>

    </swiper>


    <swiper class="swiper thumb-slider__thumbs"
            v-if="sliderItems.length > 1"
            :options="swiperOptionThumbs"
            ref="swiperThumbs">

      <swiper-slide v-for="(sliderItem, index) in sliderItems"
                    :key="`${sliderItem}-${index}-thumb`">

        <template v-if="sliderItem.video">

          <div class="thumb-slider__video">
            <img :src="sliderItem.poster" alt="">
          </div>
        </template>

        <img v-else :src="sliderItem.url" alt="">
      </swiper-slide>

    </swiper>
  </div>
</template>

<script>
  import BaseVideo from './BaseVideo';

  export default {
    name: 'ThumbSlider',
    components: {BaseVideo},
    props: {
      sliderItems: {
        type: Array,
        required: true
      }
    },
    data: () => ({
      swiperOptionMain: {
        spaceBetween: 10,
        navigation: {
          nextEl: '.thumb-slider__arrow--right',
          prevEl: '.thumb-slider__arrow--left'
        },
        resistanceRatio: 0
      },
      swiperOptionThumbs: {
        spaceBetween: 16,
        slidesPerView: 'auto',
        touchRatio: 0.2,
        slideToClickedSlide: true,
        resistanceRatio: 0
      },
      activeIndex: 0,
      startedVideos: [],
    }),
    mounted() {
      this.$nextTick(() => {
        if (this.$refs.swiperThumbs) {
          const swiperMain = this.$refs.swiperMain.$swiper;
          const swiperThumbs = this.$refs.swiperThumbs.$swiper;

          swiperMain.on('slideChange', () => {
            const activeIndex = swiperMain.activeIndex;

            Array.from(swiperThumbs.slides)
              .forEach((slide) => slide.classList.remove('is-selected'));

            Array.from(swiperThumbs.slides)
              .forEach((slide, index) =>
                index === activeIndex
                  ? slide.classList.add('is-selected')
                  : null
              );

            this.activeIndex = swiperMain.activeIndex;
            swiperThumbs.slideTo(activeIndex)
          });

          swiperThumbs.on('click', () => {
            const index = swiperThumbs.clickedIndex;

            if (typeof index === 'undefined') return;

            Array.from(swiperThumbs.slides)
              .forEach((slide) => slide.classList.remove('is-selected'));

            swiperThumbs.clickedSlide.classList.add('is-selected');

            this.activeIndex = index;
            swiperMain.slideTo(index);
          })
        }
      });

      const videos = Array.from(this.$el.querySelectorAll('.video-js'));

      videos.forEach((video) => {
        video.addEventListener('click', () => this.onStartVideo(video));
        video.addEventListener('touchstart', () => this.onStartVideo(video));
      });

    },

    watch: {
      room() {
        const videos = Array.from(this.$el.querySelectorAll('.video-js'));

        videos.forEach((video) => {
          video.addEventListener('click', () => this.onStartVideo(video));
          video.addEventListener('touchstart', () => this.onStartVideo(video));
        });
      }
    },

    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      }
    },

    methods: {
      getVideoOptions(videoObj) {
        return {
          autoplay: false,
          controls: true,
          sources: [
            {
              src: videoObj.src,
              type: videoObj.type
            }
          ],
          poster: videoObj.poster
        }
      },

      onStartVideo(video) {
        if (video.classList.contains('vjs-has-started')) return;

        video.querySelector('.vjs-control-bar').classList.add('swiper-no-swiping');
        this.startedVideos.push(this.activeIndex);
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .thumb-slider {
    max-width: 100%;

    &__main {
      @include gray-shadow;

      height: rem(430);
      width: 100%;

      border-radius: rem(8);

      img {
        width: 100%;
        height: 100%;

        object-fit: cover;
      }

      .base-video {
        border-radius: rem(4);
      }

      @media (max-width: $mobile-width) {
        height: rem(220);
      }

      .swiper-slide {
        width: 100% !important;
      }
    }

    &__thumbs {
      height: rem(112);
      padding: rem(16) !important;
      margin: 0 rem(-16) !important;
      width: calc(100% + 2rem);

      .swiper-slide {
        @include gray-shadow;

        width: calc(20% - .8rem);
        height: 100%;
        margin-right: rem(16);

        border-radius: rem(4);
        cursor: pointer;
        overflow: hidden;

        img {
          width: 100%;
          height: 100%;

          object-fit: cover;
        }
      }

      @media (max-width: $mobile-width) {
        display: none;
      }
    }

    &__arrow {
      z-index: 1;
      position: absolute;
      top: 0;

      width: rem(200);
      height: 100%;
      cursor: pointer;

      &--video {
        height: calc(100% - 30px);

        &::before {
          top: calc(50% + 15px) !important;
        }
      }

      @media (max-width: $mobile-width) {
        width: rem(100);
      }

      &.swiper-button-disabled {
        display: none;
      }

      &::before {
        content: '';

        position: absolute;
        top: 50%;
        transform: translateY(-50%);

        width: rem(10);
        height: rem(20);

        background: url('/images/icon-slider-arrow.svg') center no-repeat;
        background-size: contain;

        opacity: .5;

        @media (max-width: $mobile-width) {
          width: rem(8);
          height: rem(16);
        }
      }

      &--left {
        left: 0;
        background: transparent;

        &::before {
          left: rem(40);

          transform: translateY(-50%) rotate(180deg);
        }

        &:hover:not(.swiper-button-disabled) {
          background: linear-gradient(90deg, rgba($black, .3) 23.18%, rgba($black, 0) 100%);

          &::before {
            opacity: 1;
          }
        }

        @media (max-width: $mobile-width) {
          &::before {
            left: rem(16);
          }

          background: linear-gradient(90deg, rgba($black, .3) 23.18%, rgba($black, 0) 100%);

          &::before {
            opacity: 1;
          }
        }
      }

      &--right {
        right: 0;
        background: transparent;

        &::before {
          right: rem(40);
        }

        &:hover:not(.swiper-button-disabled) {
          background: linear-gradient(-90deg, rgba($black, .3) 23.18%, rgba($black, 0) 100%);

          &::before {
            opacity: 1;
          }
        }

        @media (max-width: $mobile-width) {
          &::before {
            right: rem(16);
          }

          background: linear-gradient(-90deg, rgba($black, .3) 23.18%, rgba($black, 0) 100%);

          &::before {
            opacity: 1;
          }
        }
      }
    }

    &__video {
      &::before {
        content: '';

        position: absolute;
        z-index: 1;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);

        width: rem(46);
        height: rem(46);

        background: $gradient-green;

        border: rem(1) solid rgba($white, 0.1);
        border-radius: 50%;
        box-shadow: rem(10) rem(10) rem(30) rgba(84, 211, 194, 0.3),
          inset rem(16) rem(16) rem(30) rgba($white, 0.2);
      }

      &::after {
        content: '';

        position: absolute;
        z-index: 1;
        top: 50%;
        left: 50%;
        transform: translate(calc(-50% + .0625rem), -50%);

        width: rem(8);
        height: rem(12);

        background: url('/images/icon-play-min.svg') no-repeat;
        background-size: contain;
      }
    }
  }
</style>
